package operation

import (
	"shylinux.com/x/community/src/api"
	"shylinux.com/x/ice"
	"shylinux.com/x/icebergs/base/aaa"
	"shylinux.com/x/icebergs/base/ctx"
	"shylinux.com/x/icebergs/base/mdb"
	"shylinux.com/x/icebergs/base/web"
	"shylinux.com/x/operation/src/operation/model"
	kit "shylinux.com/x/toolkits"
)

type project struct {
	Table
	cluster     cluster
	gateway     gateway
	order       string `data:"3"`
	fields      string `data:"name,repos,binary,gateway_uid"`
	create      string `name:"create name* repos binary" style:"notice" role:"worker"`
	scanProduct string `name:"scanProduct" help:"扫描" role:"worker"`
	open        string `name:"name" role:"worker"`
}

func (s project) Create(m *ice.Message, arg ...string) {
	if s.Select(m.Spawn(), m.OptionSimple(model.CLOUD_UID, model.GATEWAY_UID, mdb.NAME)...).Length() > 0 {
		return
	}
	msg := m.Cmd(web.SPACE, m.Option(web.SPACE), web.DREAM, mdb.CREATE, arg, kit.Dict(ice.MSG_USERROLE, aaa.TECH))
	s.Insert(m, kit.Simple(arg, msg.OptionSimple(model.CLOUD_UID, model.GATEWAY_UID, mdb.NAME))...)
}
func (s project) List(m *ice.Message, arg ...string) {
	s.ValueList(m, arg).PushAction(s.ScanProduct, s.Open).Action().Display("")
	if m.Length() == 0 {
		m.SetResult().Echo("请到「云主机」创建项目")
	}
	s.Fields(m, model.UID, s.KeyAS(s.gateway, model.TITLE)).SelectJoin(m, s.gateway, s.Keys(s.gateway, model.TITLE))
}
func (s project) ScanProduct(m *ice.Message, arg ...string) {
	m.Cmd(web.SPACE, s.space(m), api.GONGANXITONG_PORTAL)
	m.Cmd(web.SPACE, s.space(m), api.GONGANXITONG_SERVICE).Table(func(value ice.Maps) {
		m.Cmd(product{}, s.InsertIfNeed, ctx.INDEX, value[ctx.INDEX], mdb.NAME, value[mdb.NAME], model.PROJECT_UID, m.Option(model.UID), m.OptionSimple(model.CLOUD_UID))
	})
	m.ProcessRefresh()
}
func (s project) Open(m *ice.Message, arg ...string) {
	m.ProcessOpen(m.Options(ice.MSG_USERPOD, "").MergePodCmd(s.space(m), web.ADMIN))
}

func init() { ice.TeamCtxCmd(project{}) }

func (s project) space(m *ice.Message, arg ...string) string {
	s.Tables(m, s.gateway, s.cluster).Fields(m, s.Key(s, mdb.NAME), s.KeyAS(s.gateway, web.SPACE), s.KeyAS(s.cluster, web.SPACE))
	s.Select(m, kit.Simple(s.Key(s, model.CLOUD_UID), m.Option(model.CLOUD_UID), s.Key(s, model.UID), m.Option(model.UID))...)
	return kit.Keys(m.Append(model.CLUSTER_SPACE), m.Append(model.GATEWAY_SPACE), m.Append(mdb.NAME))
}
